let username="";
let finalScore="";
let exerciseName="";
let difficulty="";

function timerString(timeDiff){
    let seconds = Math.round(timeDiff);
    let minutes = Math.floor(seconds / 60);
    let hours = Math.floor(minutes / 60);
    seconds %= 60;
    minutes %= 60;
    if (seconds < 10) {
        seconds = "0" + seconds
    }
    if (minutes < 10) {
        minutes = "0" + minutes
    }
    if (hours < 10) {
        hours = "0" + hours
    }
    return [seconds,minutes,hours];
}
$(document).ready(function () {
    const queryString = window.location.search;
    const urlParams = new URLSearchParams(queryString);
    var coords = eval(urlParams.get('points'));
    username = urlParams.get('user');
    exerciseName = urlParams.get('exerciseName');
    difficulty = urlParams.get('difficulty');
    //coords.pop();
    console.log(coords);
    let timer = document.getElementById("timer");
    let startingTime;
    let timerInterval = false;
    let seconds = 00;
    let minutes = 00;
    let hours = 00;
    let tens = 00;
    let appendSeconds = document.getElementById("seconds");
    let appendMinutes = document.getElementById("minutes");
    let appendHours = document.getElementById("hours");
    let canStartTimer = true;

    function updateTimer() {
        console.log("Updating timer");
        let currentTime = new Date();
        let timeDiff = (currentTime - startingTime) / 1000;
        let timer=timerString(timeDiff);
        appendSeconds.innerHTML = "" + timer[0];
        appendMinutes.innerHTML = "" + timer[1];
        appendHours.innerHTML = "" + timer[2];
        finalScore=timeDiff;
    }

    function stopTimer() {
        clearInterval(timerInterval);
    }

    function drawLineFromAtoB(x1, y1, x2, y2, i) {
        var m = (y2 - y1) / (x2 - x1);
        var angle = (Math.atan(m)) * 180 / (Math.PI);
        var d = Math.sqrt(((x2 - x1) * (x2 - x1)) + ((y2 - y1) * (y2 - y1)));
        var transform;
        if (x2 >= x1) {
            transform = (360 + angle) % 360;
        } else {
            transform = 180 + angle;
        }
        var id = 'line_' + new Date().getTime();
        var line = "<div id='" + id + "'class='line'>&nbsp;</div>";
        $('#canvas').append(line);
        $('#' + id).css({
            'left': x1,
            'top': y1,
            'width': '0px',
            'transform': 'rotate(' + transform + 'deg)',
            'transform-origin': '0px 0px',
            '-ms-transform': 'rotate(' + transform + 'deg)',
            '-ms-transform-origin': '0px 0px',
            '-moz-transform': 'rotate(' + transform + 'deg)',
            '-moz-transform-origin': '0px 0px',
            '-webkit-transform': 'rotate(' + transform + 'deg)',
            '-webkit-transform-origin': '0px 0px',
            '-o-transform': 'rotate(' + transform + 'deg)',
            '-o-transform-origin': '0px 0px'
        });

        $('#' + id).animate(
            {
                width: d,
            }, 1000,
            "linear",
            function () {
                if (i < coords.length) {
                    $('div#dot_container_' + (i + 1)).addClass('active');
                }
            }
        );
    }

    for (let i = 0; i < coords.length; i++) {
        css = {
            left: coords[i][0] - 6,
            top: coords[i][1] - 17,
            zIndex: coords.length - i
        };
        class_active = (i == 0) ? ' active' : '';
        div = $('<div id="dot_container_' + i + '" order_value="' + i + '" class="dot_container' + class_active + '"><div class="dot"></div><div class="dot_number">' + (i + 1) + '</div></div>').css(css);
        $('#canvas').append(div);
    }

    $('.dot_container').click(function () {
        if (canStartTimer && !timerInterval) {
            console.log("starting timer");
            startingTime = new Date();
            timerInterval = setInterval(updateTimer, 1000);
            canStartTimer = false;
        }
        if ($(this).hasClass('active')) {
            var i = parseInt($(this).attr('order_value'));
            $(this).removeClass('active');
            if (i == 0) {
                $('div#dot_container_' + (i + 1)).addClass('active');
                return false;
            }
            x1 = coords[i - 1][0];
            y1 = coords[i - 1][1];
            x2 = coords[i][0];
            y2 = coords[i][1];
            drawLineFromAtoB(x1, y1, x2, y2, i);
            if (i == coords.length - 1) {
                clearInterval(timerInterval);
                setTimeout(function () {
                    //connect with the initial point
                    drawLineFromAtoB(x2, y2, coords[0][0], coords[0][1], i);
                }, 1100);
                saveData();
                revealImage();
            }

        }

    });

    function revealImage() {
        console.log("reveal called");
        return;
        $('.dot_container,.line').animate({
            opacity: 0
        }, 1000, "linear", function () {
            $('.hidden_image').animate({
                opacity: 1
            }, 1000, "linear", function () {
                $('.hidden_image').addClass('animate');
            });
        });
    };

});
function obtainBestScore(){
    let record=localStorage.getItem("score"+username+"--"+exerciseName+"--"+difficulty);
    if(record){
        return record;
    }else{
        return -1;
    }
}
function saveData(){
    let record=obtainBestScore();
    let recordString="";
    if(record>0){
        let recordArray=timerString(record);
        recordString="Record: "+recordArray[2]+":"+recordArray[1]+":"+recordArray[0];
    }
    if(finalScore<record || record<0){
        localStorage.setItem("score"+username+"--"+exerciseName+"--"+difficulty,finalScore);
    }
    $.ajax({
        type: "POST",
        url: "saveData.php",
        data: {
            'seconds': finalScore,
            'user': username,
            'exercise': exerciseName,
            'difficulty': difficulty
        },
        success: function (data) {
            console.log(data);
        }
    });
    let scoreArray=timerString(finalScore);
    setTimeout(function(){
        alert("Current score: "+scoreArray[2]+":"+scoreArray[1]+":"+scoreArray[0]+" , "+recordString);
    },3000);
}
