let geom = {};
const d3_geom_contourDx = [1, 0, 1, 1, -1, 0, -1, 1, 0, 0, 0, 0, -1, 0, -1, NaN];
const d3_geom_contourDy = [0, -1, 0, 0, 0, -1, 0, 0, 1, -1, 1, 1, 0, -1, 0, NaN];
geom.contour = function (grid, start) {
    console.log("contour activated");
    console.log(grid);
    console.log(start);
    let s = start || d3_geom_contourStart(grid), // starting point
        c = [],    // contour polygon
        x = s[0],  // current x position
        y = s[1],  // current y position
        dx = 0,    // next x direction
        dy = 0,    // next y direction
        pdx = NaN, // previous x direction
        pdy = NaN, // previous y direction
        i = 0;
    do {
        // determine marching squares index
        i = 0;
        if (grid(x - 1, y - 1)) {
            i += 1;
        }
        if (grid(x, y - 1)) {
            i += 2;
        }
        if (grid(x - 1, y)) {
            i += 4;
        }
        if (grid(x, y)) {
            i += 8;
        }

        // determine next direction
        if (i === 6) {
            dx = pdy === -1 ? -1 : 1;
            dy = 0;
        } else if (i === 9) {
            dx = 0;
            dy = pdx === 1 ? -1 : 1;
        } else {
            dx = d3_geom_contourDx[i];
            dy = d3_geom_contourDy[i];
        }

        // update contour polygon
        if (dx != pdx && dy != pdy) {
            c.push([x, y]);
            pdx = dx;
            pdy = dy;
        }

        x += dx;
        y += dy;
    } while (s[0] != x || s[1] != y);

    return c;
};

function d3_geom_contourStart(grid) {
    let x = 0,
        y = 0;
    while (true) {
        if (grid(x, y)) {
            return [x, y];
        }
        if (x === 0) {
            x = y + 1;
            y = 0;
        } else {
            x -= 1;
            y += 1;
        }
    }
}


$(function () {
    $('.slider').on('input change', function () {
        $(this).next($('.slider_label')).html(this.value);
    });
    $('.slider_label').each(function () {
        let value = $(this).prev().attr('value');
        $(this).html(value);
    });
});


document.querySelectorAll(".__range-step").forEach(function (ctrl) {
    let el = ctrl.querySelector('input');
    let output = ctrl.querySelector('output');
    let newPoint, newPlace, offset;
    el.oninput = function () {
        // colorize step options
        ctrl.querySelectorAll("option").forEach(function (opt) {
            if (opt.value <= el.valueAsNumber)
                opt.style.backgroundColor = 'green';
            else
                opt.style.backgroundColor = '#aaa';
        });
        // colorize before and after
        let valPercent = (el.valueAsNumber - parseInt(el.min)) / (parseInt(el.max) - parseInt(el.min));
        let style = 'background-image: -webkit-gradient(linear, 0% 0%, 100% 0%, color-stop(' +
            valPercent + ', green), color-stop(' +
            valPercent + ', #aaa));';
        el.style = style;

        // Popup
        if ((' ' + ctrl.className + ' ').indexOf(' ' + '__range-step-popup' + ' ') > -1) {
            let selectedOpt = ctrl.querySelector('option[value="' + el.value + '"]');
            output.innerText = selectedOpt.text;
            output.style.left = "50%";
            output.style.left = ((selectedOpt.offsetLeft + selectedOpt.offsetWidth / 2) - output.offsetWidth / 2) + 'px';
        }
    };
    el.oninput();
});

