console.log("starting");
let exerciseName="";
let difficulty=10;
let drawed = false;
let images = [
    "dog",      // 0
    "hammer",   // 1
    "driller",  // 2
    "pig",      // 3
    "ship",     // 4
    "star",     // 5
    "pen",      // 6
    "pentagon", // 7
    "hat",      // 8
    "lens"      // 9
];
let i = 0;
let url = "";
let imgData, data;
let cw;
let img;
let canvas, ctx;
let $showImage = $("#showImage");
let $showOutline = $("#showOutline");
let numberOfDots;
let defineNonTransparent = function (x, y) {
    return (data[(y * cw + x) * 4 + 3] > 0);
};
let points;

function draw() {
    document.getElementById("canvas").style.display="unset";
    document.getElementById("imgLineaShapes").style.display="none";
    console.log("drawing");
    i = document.getElementById("items").value;
    numberOfDots = document.getElementById("numberOfDots").value;
    difficulty=parseInt(numberOfDots);
    exerciseName=document.getElementById("items").options[document.getElementById("items").selectedIndex].text;
    canvas = document.getElementById("canvas");
    ctx = canvas.getContext("2d");
    ctx.imageSmoothingEnabled = false;
    ctx.clearRect(0, 0, canvas.width, canvas.height);
    cw = canvas.width;
    img = new Image();
    let src = "images/" + images[i] + ".svg?ver=2";
    loadSVGimage(src);
    document.getElementById("message").style.display="unset";
}

function drawCoordinates(x, y) {
    console.log("drawCoordinates");
    let pointSize = 3;
    let ctx = document.getElementById("canvas").getContext("2d");
    ctx.imageSmoothingEnabled = false;
    ctx.fillStyle = "green";
    ctx.beginPath();
    ctx.arc(x, y, pointSize, 0, Math.PI * 2, true);
    ctx.fill();
}

function redraw() {
    console.log("redraw");
    ctx.imageSmoothingEnabled = false;
    ctx.clearRect(0, 0, canvas.width, canvas.height);
    if ($showImage.is(':checked')) {
        ctx.drawImage(img, 0, 0);
    }
    if ($showOutline.is(':checked')) {
        ctx.beginPath();
        ctx.moveTo(points[0][0], points[0][4]);
        console.log("for n1");
        for (let i = 1; i < points.length; i++) {
            let point = points[i];
            ctx.lineTo(point[0], point[1]);
        }
        ctx.closePath();
        ctx.stroke();
    }
    console.log("for n2");
    for (let i = 1; i < points.length; i++) {
        let point = points[i];
        drawCoordinates(point[0], point[1])
    }
    drawed = true;
}

function gotoURL() {
    if (!drawed) return;
    let user = "";
    while (user == "") {
        user = prompt("Insert username: ", "patient0");
    }
    if (url != "") {
        location.href="./exercise.html?exerciseName="+exerciseName+"&difficulty="+difficulty+"&user=" + user + "&points=" + url;
    }
}

function loadSVGimage(src) {
    let request = new XMLHttpRequest();
    request.open('GET', src, true);

    request.onload = function () {
        let parser = new DOMParser();
        let result = parser.parseFromString(request.responseText, 'text/xml');
        let inlineSVG = result.getElementsByTagName("svg")[0];
        inlineSVG.setAttribute('width', '700px');
        inlineSVG.setAttribute('height', '600px');
        let svg64 = btoa(new XMLSerializer().serializeToString(inlineSVG));
        console.log(svg64);
        img.src = 'data:image/svg+xml;base64,' + svg64;
        img.onload = function () {
            canvas.width = this.width;
            canvas.height = this.height;
            ctx = canvas.getContext("2d");
            ctx.drawImage(this, 0, 0);
            imgData = ctx.getImageData(0, 0, canvas.width, canvas.height);
            data = imgData.data;
            console.log("calculating contour");
            console.log(data);
            let totalPoints = geom.contour(defineNonTransparent);
            console.log("contour calculated");
            points = [];
            url = "[";
            let step = Math.floor(totalPoints.length / numberOfDots);
            //step=1;
            let start = Math.floor(Math.random() * totalPoints.length);
            let newElement = "";
            for (let j = 0; j < totalPoints.length; j += step) {
                if (newElement != "") {
                    url += newElement;
                }
                points.push(totalPoints[(j + start) % totalPoints.length]);
                newElement = "[" + totalPoints[j][0] + "," + totalPoints[j][1] + "],";
            }
            url = url.slice(0, -1) + "]";
            console.log(points);
            ctx.strokeStyle = "red";
            ctx.lineWidth = 2;
            redraw();
        };
    };
    request.send();
}

let openCVimages= {
    "1easy":"[[85,94],[85,435],[671,435],[671,94]]",
    "1medium":"[[85,94],[85,264],[85,435],[378,435],[671,435],[671,264],[671,94],[378,94]]",
    "2easy":"[[391,202],[391,391],[484,391],[486,486],[882,486],[883,392],[977,391],[977,202],[884,202],[883,108],[486,108],[485,202]]",
    "2medium":"[[391,202],[391,296],[391,391],[438,391],[484,391],[485,438],[486,486],[684,486],[882,486],[882,439],[883,392],[930,392],[977,391],[977,296],[977,202],[930,202],[884,202],[884,155],[883,108],[684,108],[486,108],[486,155],[485,202],[438,202]]",
    "3easy":"[[245,249],[245,346],[315,416],[762,416],[832,346],[832,249],[762,179],[315,179]]",
    "3medium":"[[245,249],[245,298],[245,346],[280,381],[315,416],[538,416],[762,416],[797,381],[832,346],[832,298],[832,249],[797,214],[762,179],[538,179],[315,179],[280,214]]",
    "4easy":"[[359,185],[292,402],[76,402],[252,538],[186,752],[358,621],[532,752],[467,537],[643,402],[426,402]]",
    "4medium":"[[359,185],[326,294],[292,402],[184,402],[76,402],[164,470],[252,538],[219,645],[186,752],[272,686],[358,621],[445,686],[532,752],[500,644],[467,537],[555,470],[643,402],[534,402],[426,402],[392,294]]",
    "5easy":"[[992,434],[874,382],[873,407],[757,407],[756,330],[582,330],[582,279],[638,278],[520,226],[401,279],[457,279],[457,330],[283,330],[282,407],[167,407],[165,382],[47,435],[165,487],[167,462],[282,462],[283,539],[457,539],[457,590],[401,591],[520,643],[638,591],[582,590],[582,539],[756,539],[757,462],[873,462],[875,487]]",
    "5medium":"[[992,434],[933,408],[874,382],[874,394],[873,407],[815,407],[757,407],[756,368],[756,330],[669,330],[582,330],[582,304],[582,279],[610,278],[638,278],[579,252],[520,226],[460,252],[401,279],[429,279],[457,279],[457,304],[457,330],[370,330],[283,330],[282,368],[282,407],[224,407],[167,407],[166,394],[165,382],[106,408],[47,435],[106,461],[165,487],[166,474],[167,462],[224,462],[282,462],[282,500],[283,539],[370,539],[457,539],[457,564],[457,590],[429,590],[401,591],[460,617],[520,643],[579,617],[638,591],[610,590],[582,590],[582,564],[582,539],[669,539],[756,539],[756,500],[757,462],[815,462],[873,462],[874,474],[875,487],[934,460]]",
};

function drawLinearShapes(){
    console.log("drawing");
    i = document.getElementById("items2").value;
    numberOfDots = document.getElementById("numberOfDots2").value;
    difficulty=parseInt(numberOfDots);
    let name="";
    if(difficulty==1){difficulty="easy";name="_e";}
    else if(difficulty==2){difficulty="medium";name="_m";}
    exerciseName=document.getElementById("items2").options[document.getElementById("items2").selectedIndex].text;
    document.getElementById("canvas").style.display="none";
    let img=document.getElementById("imgLineaShapes");
    img.style.display="unset";
    img.src="images/"+i+name+".png";
    drawed=true;
    url=openCVimages[""+i+difficulty];
    document.getElementById("message").style.display="unset";
}
