import cv2
import numpy as np
import os


def coordinates(filepath='', k=0.03):
    image = cv2.imread(filepath)
    gray_scale = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)
    threshold = cv2.threshold(gray_scale, 0, 255, cv2.THRESH_BINARY_INV + cv2.THRESH_OTSU)[1]
    contours = cv2.findContours(threshold, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
    contour = contours[0] if len(contours) == 2 else contours[1]
    poly_approximation = None
    for c in contour:
        poly_perimeter = cv2.arcLength(c, True)
        poly_approximation = cv2.approxPolyDP(c, k * poly_perimeter, True)
    return poly_approximation


def double(x):
    ok = isinstance(x, type(np.array([])))
    ok = ok and len(x.shape) == 2 and x.shape[1] == 2
    if not ok:
        raise ValueError('x must be a numpy array with size (*,2)')

    y = np.zeros((1, 2), dtype=x.dtype)
    y += x[0]
    for i in range(x.shape[0]):
        p = x[i:i+2]
        if p.shape[0] == 1:
            p = np.append(p, np.expand_dims(x[0], axis=0), axis=0)
        pm = np.around(np.mean(p, axis=0)).astype(x.dtype)
        y = np.append(y, np.expand_dims(pm, axis=0), axis=0)
        y = np.append(y, np.expand_dims(p[1], axis=0), axis=0)
    return y[:-1]


pa = []
for item in sorted(os.listdir(os.path.abspath(os.path.curdir))):
    if item.startswith('image') and item.endswith(('jpeg', 'jpg', 'png')):
        src_filename = os.path.join(os.path.abspath(os.path.curdir), item)
        coord = coordinates(src_filename, 0.005)
        pa.append(coord)
        dst_filename = src_filename[:src_filename.rfind('.')] + '.txt'
        with open(dst_filename, 'w') as f:
            m = np.squeeze(coord, axis=1)
            b = [list(_) for _ in list(m)]
            s = str(b)
            s = s.replace('\n', ',')
            s = s.replace(' ', '')
            f.write(s + '\n')
            n = double(m)
            b = [list(_) for _ in list(n)]
            s = str(b)
            s = s.replace('\n', ',')
            s = s.replace(' ', '')
            f.write(s + '\n')
print('FINE')
